set(PROGRAM_FILES
    "$ENV{ProgramFiles\(x86\)}"
    "$ENV{ProgramFiles}"
)
set(BASE_PATH "Microsoft Visual Studio/2022")

foreach (check ${PROGRAM_FILES})
    if (EXISTS "${check}/${BASE_PATH}")
        set(VS_PATH "${check}/${BASE_PATH}")
        break()
    endif ()
endforeach ()
if (NOT VS_PATH)
    message(FATAL_ERROR "Visual Studio 2022 not found")
endif ()
if(EXISTS "${VS_PATH}/Community")
    set(VS_EDITION "Community")
elseif(EXISTS "${VS_PATH}/Professional")
    set(VS_EDITION "Professional")
elseif(EXISTS "${VS_PATH}/Enterprise")
    set(VS_EDITION "Enterprise")
else()
    message(FATAL_ERROR "Visual Studio 2022 edition not found")
endif()
set(VS_TOOLCHAIN_PATH "${VS_PATH}/${VS_EDITION}/VC/Tools/MSVC")

file(GLOB VS_VERSION_DIR "${VS_TOOLCHAIN_PATH}/*")
list(GET VS_VERSION_DIR 0 VS_LATEST_VERSION)
if(NOT EXISTS "${VS_LATEST_VERSION}")
    message(FATAL_ERROR "Visual Studio 2022 version not found")
endif ()
string(REGEX REPLACE "\\\\" "/" VS_LATEST_VERSION "${VS_LATEST_VERSION}")
set(CMAKE_C_COMPILER "${VS_LATEST_VERSION}/bin/Hostx64/x64/cl.exe")
set(CMAKE_CXX_COMPILER "${VS_LATEST_VERSION}/bin/Hostx64/x64/cl.exe")
set(CMAKE_GENERATOR "Ninja")